    /*
 * ContestantImpl.java
 *
 * Created on Pondelok, 2007, december 3, 14:40
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */
package cz.muni.fi.pb162.timetrial;

import java.util.Date;

/**
 * TimeTrial contestant identified by start number, described by name
 * 
 * @author misko
 */
public final class ContestantImpl implements Contestant {

    private final int startNumber;
    private final String fullName;
    private Date startTime;
    private Date time = null;

    /**
     * Creates new contestant identified by no described by name
     * @param startNumber start number of the contestant
     * @param fullName full name (name surname) of the contestant
     */
    public ContestantImpl(int no, String fullName) {
        this.startNumber = no;
        this.fullName = fullName;
    }

    /**
     * Informs whether several object is equal to this contestant what means
     * it is a contestant and has the same start number
     * @param obj object to equal
     * @return <code>true</code> if the object is a contestant whith the same 
     *      start number, <code>false</code> otherwise
     */
    @Override
    public boolean equals(Object obj) {
    }

    /**
     * Generates hash code of this object. The only atribute is start number
     * 
     * @return hash code of this object
     */
    @Override
    public int hashCode() {
    }

    /**
     * Compares this contestant with another one. Ordering is by (time,id)
     * lexicographicly. Object with n/a time are considered as the had infinite time
     * @param o contestant to compare
     * @return -1 if the this contestant is better than the compared with xor 
     * he has lower start number,  0 if they are equal, 1 otherwise
     */
    @Override
    public int compareTo(Contestant o) {
    }

    /**
     * Gives contestat's start nuber
     * @return contestat's start nuber
     */
    public int getStartNumber() {
        return startNumber;
    }

    /**
     * Gives contestat's name
     * @return contestat's name
     */
    public String getFullName() {
        return fullName;
    }

    /**
     * Informs whether contestant has allready started
     * @return true if contestant has started, false otherwise
     */
    public boolean hasStarted() {
    }

    /**
     * Gives contestat's start time
     * @return contestat's start time
     */
    public Date getStartTime() {
    }

    /**
     * Start this contestant, the time begins to run
     * @param startTime date/time of start
     * @throws IllegalStateException if contestant allready started
     */
    void start(Date startTime) {
    }

    /**
     * Finish this contestant's performance, the time stops
     * @param startTime date/time of entering the finish
     * @throws IllegalStateException if contestant not started
     */
    void finish(Date finishTime) {
    }

    /**
     * Gives contestant's time -- the subtraction of finish time and start time
     * @return the subtraction of finish time and start time
     * @throws IllegalStateException if the performance has not been finished yet
     */
    public Date getTime() {
    }

    /**
     * Gives the textual representation of the contestant
     * @return textual representation of the contestant (<full name> (No <start number>)
     */
    @Override
    public String toString() {
        return fullName + " (No " + startNumber + ")";
    }
}
